-- Create table
create table TR_MIT_KLADR
(
  SNAME   VARCHAR2(40),
  SSOCR   VARCHAR2(10),
  SCODE   VARCHAR2(13) not null,
  SINDEX  VARCHAR2(6),
  SGNINMB VARCHAR2(4),
  SUNO    VARCHAR2(4),
  SOCATD  VARCHAR2(11),
  SSTATUS VARCHAR2(1)
)
tablespace PARUS_MAIN
  pctfree 10
  pctused 40
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );
-- Create/Recreate primary, unique and foreign key constraints 
alter table TR_MIT_KLADR
  add constraint PR_MIT_KLADR_PK primary key (SCODE)
  using index 
  tablespace PARUS_INDEX
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );

-- Create table
create table TR_MIT_STREET
(
  SNAME   VARCHAR2(40),
  SSOCR   VARCHAR2(10),
  SCODE   VARCHAR2(17) not null,
  SINDEX  VARCHAR2(6),
  SGNINMB VARCHAR2(4),
  SUNO    VARCHAR2(4),
  SOCATD  VARCHAR2(11)
)
tablespace PARUS_MAIN
  pctfree 10
  pctused 40
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );
-- Create/Recreate primary, unique and foreign key constraints 
alter table TR_MIT_STREET
  add constraint TR_MIT_STREET_PK primary key (SCODE)
  using index 
  tablespace PARUS_INDEX
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );
-- Create table
create table TR_MIT_DOMA
(
  SNAME   VARCHAR2(40),
  SKORP   VARCHAR2(10),
  SSOCR   VARCHAR2(10),
  SCODE   VARCHAR2(19) not null,
  SINDEX  VARCHAR2(6),
  SGNINMB VARCHAR2(4),
  SUNO    VARCHAR2(4),
  SOCATD  VARCHAR2(11)
)
tablespace PARUS_MAIN
  pctfree 10
  pctused 40
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );
-- Create/Recreate primary, unique and foreign key constraints 
alter table TR_MIT_DOMA
  add constraint TR_MIT_DOMA_PK primary key (SCODE)
  using index 
  tablespace PARUS_INDEX
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );
-- Create table
create table TR_MIT_ALTNAMES
(
  SOLDCODE VARCHAR2(19) not null,
  SNEWCODE VARCHAR2(19) not null,
  SLEVEL   VARCHAR2(1) not null
)
tablespace PARUS_MAIN
  pctfree 10
  pctused 40
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );

-- Create table
create table TR_MIT_KLADR_PROM
(
  CODE    VARCHAR2(19) not null,
  GEO_RN  NUMBER(17) not null,
  COMPANY NUMBER(17) not null
)
tablespace PARUS_MAIN
  pctfree 10
  pctused 40
  initrans 1
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );
-- Create/Recreate primary, unique and foreign key constraints 
alter table TR_MIT_KLADR_PROM
  add constraint PR_MIT_KLADR_PROM_PK primary key (CODE)
  using index 
  tablespace PARUS_INDEX
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );

create index TR_MIT_KLADR_PROM_COMPANY on TR_MIT_KLADR_PROM (COMPANY)
  tablespace PARUS_INDEX
  pctfree 10
  initrans 2
  maxtrans 255
  storage
  (
    initial 64K
    minextents 1
    maxextents unlimited
  );

-- 
create or replace procedure find_geografy_by_code
(
nCompany number, --   
scode varchar2,
nRn out number --   
)
as
nVersion number( 15 );
begin
select tr.geo_rn into nrn from tr_mit_kladr_prom tr where tr.company=ncompany and tr.code=scode;
exception when no_data_found then  nrn:=NULL;
/*nRn := null;
\*   *\
find_version_by_company( nCompany,'GEOGRAFY',nVersion );
\*   *\
begin
select
rn
into
nRn
from
geografy g,
tr_mit_kladr_prom tr
where
g.version = nVersion
and tr.ncompany=nCompany
and 
g.okato = scode
and rownum = 1;
exception
when no_data_found then
p_exception(nflag_smart,'    "'||scode||'"  .' );*/
end;
/

create or replace procedure pr_mit_kladr_import(ncompany number,
                                                sName  varchar2,
                                                sSocr  varchar2,
                                                sCode  varchar2,
                                                sokato varchar2,
                                                sIndex varchar2,
                                                nlocaltype in number) is
/*  nCompany pkg_std.tRef := 39481001;*/
  nRnLT    pkg_std.tRef;
  sGeoType localitytype.geographytype%type;
  nRnGeo   pkg_std.tRef; --    .
  nRnGeo1  pkg_std.tRef; -- 
  nRnGeo2  pkg_std.tRef;
  k        number(17);
  sname2    varchar2(40);
 begin
  /*     */
  parus.find_geografy_by_name(ncompany   => nCompany,
                              sgeogrname => '2',
                              sgeogrtype => '1',
                              nrn        => nRnGeo1);
  if nRnGeo1 is null then
    p_exception(0,
                '  RN   ""!!!');
  end if;
  /*    . */
  nRnGeo := nRnGeo1;
  if Length(sCode) = 13 then
    /*      . */
    if substr(sCode, 3, 11) = '00000000000' then
      /*  */
      find_geographytype_name(nflag_smart => 1,
                              sname       => '',
                              sgeogrtype  => sGeoType);
      /*    . */
      nRnGeo := nRnGeo1;
    else
      if substr(sCode, 6, 8) = '00000000' then
        /*  */
        find_geographytype_name(nflag_smart => 1,
                                sname       => '',
                                sgeogrtype  => sGeoType);
        /*    . */
        find_geografy_by_code(nCompany => nCompany,
                               scode   => substr(sCode, 1, 2) ||
                                           '00000000000',
                               nrn      => nRnGeo);
      else
        if substr(sCode, 9, 5) = '00000' then
          /*  */
          find_geographytype_name(nflag_smart => 1,
                                  sname       => '',
                                  sgeogrtype  => sGeoType);
          /*    . */
          find_geografy_by_code(nCompany => nCompany,
                                 scode   => substr(sCode, 1, 5) ||
                                             '00000000',
                                 nrn      => nRnGeo);
        else
          /*   */
          find_geographytype_name(nflag_smart => 1,
                                  sname       => ' ',
                                  sgeogrtype  => sGeoType);
          /*    . */
          find_geografy_by_code(nCompany => nCompany,
                                 scode   => substr(sCode, 1, 8) || '00000',
                                 nrn      => nRnGeo);
        end if;
      end if;
    end if;
  else
    /*  */
    find_geographytype_name(nflag_smart => 1,
                            sname       => '',
                            sgeogrtype  => sGeoType);
    /*    . */
    find_geografy_by_code(nCompany    => nCompany,
                           --nFlag_Smart => 1,
                           scode      => substr(sCode, 1, 11) || '00', --  
                           nrn         => nRnGeo);
    sGeoType := '5'; --
  end if;
  if nRnGeo is not null then
    /*   . */
    if nlocaltype=1 then 
    find_localitytype_name(nflag_smart    => 1,
                           ncompany       => nCompany,
                           sname          => sSocr,
                           sgeographytype => sGeoType,
                           nrn            => nRnLT);
    if nRnLT is null then
      /*    . */
      p_localitytype_base_insert(ncompany       => nCompany,
                                 sname          => sSocr,
                                 sgeographytype => sGeoType,
                                 nrn            => nRnLT);
    
    end if;
    sname2:=sname;
    else sname2:=sname||' '||sSocr;
    end if;
    /*   . */
    FIND_GEOGRAFY_BY_NAME_EX(nflag_smart => 1,
                             ncompany    => nCompany,
                             nprn        => nRnGeo,
                             sm_name     => null,
                             sgeogrname  => sName2,
                             sgeogrtype  => sGeoType,
                             nrn         => nRnGeo2);
    if nRnGeo2 is null then
      begin
      p_geografy_base_insert(ncompany      => nCompany, --nCOMPANY      in number,      --   
                             nprn          => nRnGeo, --nPRN          in number,      --   .
                             sgeogrname    => sName2, --sGEOGRNAME    in varchar2,    --   .
                             sgeogrtype    => sGeoType, --sGEOGRTYPE    in varchar2,    --   .
                             nlocalitykind => nRnLT, --nLOCALITYKIND in number,      --   
                             scode         => null, -- sCODE         in varchar2,    --  .
                             sokato        => sokato , -- sOKATO        in varchar2,    --  OKATO
                             sPOSTAL_CODE  => sindex, --in varchar2,    --  
                             nrn           => nRnGeo2 --   
                             );
      insert into tr_mit_kladr_prom  values (scode, nRnGeo2,ncompany);
    exception when DUP_VAL_ON_INDEX then
  NULL;
    end;
    end if;
  end if;
end;
/

create or replace procedure pr_mit_kladr_import_main(
ncompany in number,
sRegion in varchar2, --  
nlocaltype in number)

 is
  n number(17);
  nRnGeo number(17);
  nRnGeo2 number(17);
begin
  n := 0;
  for a_ in (select a.sname sName,
                    a.ssocr sSocr,
                    a.sindex sIndex,
                    a.socatd socatd,
                    replace(a.scode,
                            substr(a.scode, 1, 8),
                            nvl((select substr(altn.snewcode, 1, 8)
                                  from TR_MIT_ALTNAMES altn
                                 where altn.soldcode =
                                       substr(a.scode, 1, 8) || '00000'),
                                substr(a.scode, 1, 8))) sCode --, a.index sIndex
               from tr_mit_kladr a
              where (substr(a.scode, 1, 2) = trim(sRegion)
                 or sRegion is null)
             and not exists (select null from tr_mit_kladr_prom t where t.company=ncompany and
             t.code= replace(a.scode,
                            substr(a.scode, 1, 8),
                            nvl((select substr(altn.snewcode, 1, 8)
                                  from TR_MIT_ALTNAMES altn
                                 where altn.soldcode =
                                       substr(a.scode, 1, 8) || '00000'),
                                substr(a.scode, 1, 8))))
              order by replace(a.scode,
                               substr(a.scode, 1, 8),
                               nvl((select substr(altn.snewcode, 1, 8)
                                     from tr_mit_altnames altn
                                    where altn.soldcode =
                                          substr(a.scode, 1, 8) || '00000'),
                                   substr(a.scode, 1, 8)))) loop
   begin
   pr_mit_kladr_import(ncompany,
                       a_.sname,
                       a_.ssocr,
                       a_.scode,
                       a_.socatd,
                       a_.sindex,
                       nlocaltype);
     end;
   -- update kladr t set t.status2 = 1 where t.rowid = a_.rowid;
    n := n + 1;
    if n = 1000 then
      n := 0;
      commit;
    end if;
  end loop;
  for a_ in (select a.sname sName, a.ssocr sSocr, a.scode sCode,a.socatd,a.sindex  --,a.index sIndex
               from TR_MIT_street a
              where (substr(a.scode, 1, 2) = trim(sRegion)
                 or sRegion is null)
                and not exists (select null from tr_mit_kladr_prom t where t.company=ncompany and t.code=a.scode)
                             order by a.scode) loop
      pr_mit_kladr_import(ncompany,
                       a_.sname,
                       a_.ssocr,
                       a_.scode,
                       a_.socatd,
                       a_.sindex,
                       nlocaltype);
    n := n + 1;
    if n = 1000 then
      n := 0;
      commit;
    end if;
  end loop;
  -- 
  for a_ in (select * from tr_mit_doma a
                  where (substr(a.scode, 1, 2) = trim(sRegion)
                  or sRegion is null)
                  and  not exists (select null from tr_mit_kladr_prom t where t.company=ncompany and t.code=a.scode)
                             order by a.scode)
loop
find_geografy_by_code(nCompany    => nCompany,
 --nFlag_Smart => 1,
scode      => substr(a_.scode, 1, 17), -- 
                     nrn         => nRnGeo);
begin
if nrngeo is not null then
p_geographyhouse_base_insert
(nCOMPANY,
  nrngeo,
  a_.sindex,
  a_.sname||a_.skorp,
 nrngeo2
);
insert into tr_mit_kladr_prom values (a_.scode, nrngeo2,ncompany);
end if;
end;
end loop;
commit;
end;
/